/*
This file is part of »zeitbild«.

Copyright 2025 'kcf' <fenris@folksprak.org>

»zeitbild« is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

»zeitbild« is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with »zeitbild«. If not, see <http://www.gnu.org/licenses/>.
 */


namespace _zeitbild.repository.resource
{
	
	/**
	 */
	type type_row = {
		kind : string;
		sub_id : int;
	};
	
	
	/**
	 */
	type type_preview = {
		kind : string;
		sub_id : int;
	};
	
	
	/**
	 */
	type type_local_resource_event_stuff = {
		event : _zeitbild.type_event_object;
		local_resource_id : int;
	}
	
	
	/**
	 */
	var _local_resource_event_store : (
		null
		|
		lib_plankton.storage.type_store<
			int,
			Record<string, any>,
			{},
			lib_plankton.storage.type_sql_table_autokey_search_term,
			Record<string, any>
		>
	) = null;
	
	
	/**
	 */
	var _local_resource_core_store : (
		null
		|
		lib_plankton.storage.type_store<
			int,
			Record<string, any>,
			{},
			lib_plankton.storage.type_sql_table_autokey_search_term,
			Record<string, any>
		>
	) = null;
	
	
	/**
	 */
	var _ics_feed_resource_store : (
		null
		|
		lib_plankton.storage.type_store<
			int,
			Record<string, any>,
			{},
			lib_plankton.storage.type_sql_table_autokey_search_term,
			Record<string, any>
		>
	) = null;
	
	
	/**
	 */
	var _resource_core_store : (
		null
		|
		lib_plankton.storage.type_store<
			_zeitbild.type_resource_id,
			/*type_row*/Record<string, any>,
			{},
			lib_plankton.storage.type_sql_table_autokey_search_term,
			/*type_preview*/Record<string, any>
		>
	) = null;
	
	
	/**
	 */
	function get_local_resource_event_store(
	) : lib_plankton.storage.type_store<
		int,
		Record<string, any>,
		{},
		lib_plankton.storage.type_sql_table_autokey_search_term,
		Record<string, any>
	>
	{
		if (_local_resource_event_store === null) {
			_local_resource_event_store = lib_plankton.storage.sql_table_autokey_store(
				{
					"database_implementation": _zeitbild.database.get_implementation(),
					"table_name": "local_resource_events",
					"key_name": "id",
				}
			);
		}
		else {
			// do nothing
		}	
		return _local_resource_event_store;
	}
	
	
	/**
	 */
	function get_local_resource_core_store(
	) : lib_plankton.storage.type_store<
		int,
		Record<string, any>,
		{},
		lib_plankton.storage.type_sql_table_autokey_search_term,
		Record<string, any>
	>
	{
		if (_local_resource_core_store === null) {
			_local_resource_core_store = lib_plankton.storage.sql_table_autokey_store(
				{
					"database_implementation": _zeitbild.database.get_implementation(),
					"table_name": "local_resources",
					"key_name": "id",
				}
			);
		}
		else {
			// do nothing
		}	
		return _local_resource_core_store;
	}
	
	
	/**
	 */
	function get_ics_feed_resource_store(
	) : lib_plankton.storage.type_store<
		int,
		Record<string, any>,
		{},
		lib_plankton.storage.type_sql_table_autokey_search_term,
		Record<string, any>
	>
	{
		if (_ics_feed_resource_store === null) {
			_ics_feed_resource_store = lib_plankton.storage.sql_table_autokey_store(
				{
					"database_implementation": _zeitbild.database.get_implementation(),
					"table_name": "ics_feed_resources",
					"key_name": "id",
				}
			);
		}
		else {
			// do nothing
		}	
		return _ics_feed_resource_store;
	}
	
	
	/**
	 */
	function get_resource_core_store(
	) : lib_plankton.storage.type_store<
		_zeitbild.type_resource_id,
		Record<string, any>,
		{},
		lib_plankton.storage.type_sql_table_autokey_search_term,
		Record<string, any>
	>
	{
		if (_resource_core_store === null) {
			_resource_core_store = lib_plankton.storage.sql_table_autokey_store(
				{
					"database_implementation": _zeitbild.database.get_implementation(),
					"table_name": "resources",
					"key_name": "id",
				}
			);
		}
		else {
			// do nothing
		}	
		return _resource_core_store;
	}
	
	
	/**
	 */
	function encode_local_resource_event(
		stuff : type_local_resource_event_stuff
	) : Record<string, any>
	{
		const encode_datetime : ((datetime : lib_plankton.pit.type_datetime) => string) = ((datetime) => {
			return lib_plankton.string.coin(
				"{{timezone_shift}}|{{date}}{{macro_time}}",
				{
					"timezone_shift": datetime.timezone_shift.toFixed(0).padStart(2, "0"),
					"date": lib_plankton.string.coin(
						"{{year}}-{{month}}-{{day}}",
						{
							"year": datetime.date.year.toFixed(0).padStart(4, "0"),
							"month": datetime.date.month.toFixed(0).padStart(2, "0"),
							"day": datetime.date.day.toFixed(0).padStart(2, "0"),
						}
					),
					"macro_time": (
						(datetime.time === null)
						?
						""
						:
						lib_plankton.string.coin(
							"T{{hour}}:{{minute}}:{{second}}",
							{
								"hour": datetime.time.hour.toFixed(0).padStart(2, "0"),
								"minute": datetime.time.minute.toFixed(0).padStart(2, "0"),
								"second": datetime.time.second.toFixed(0).padStart(2, "0"),
							}
						)
					),
				}
			);
		});
		return {
			"local_resource_id": stuff.local_resource_id,
			"name": stuff.event.name,
			"begin": encode_datetime(stuff.event.begin),
			"end": (
				(stuff.event.end === null)
				?
				null
				:
				encode_datetime(stuff.event.end)
			),
			"location": stuff.event.location,
			"link": stuff.event.link,
			"description": stuff.event.description,
		}
	}
	
	
	/**
	 */
	function decode_local_resource_event(
		row : Record<string, any>
	) : type_local_resource_event_stuff
	{
		const decode_datetime : ((datetime_raw : string) => lib_plankton.pit.type_datetime) = ((datetime_raw) => {
			const parts : Array<string> = datetime_raw.split("|");
			const timezone_shift : int = parseInt(parts[0]);
			if (parts[1].length <= 10) {
				return {
					"timezone_shift": timezone_shift,
					"date": {
						"year": parseInt(parts[1].slice(0, 4)),
						"month": parseInt(parts[1].slice(5, 7)),
						"day": parseInt(parts[1].slice(8, 10)),
					},
					"time": null
				};
			}
			else {
				return {
					"timezone_shift": timezone_shift,
					"date": {
						"year": parseInt(parts[1].slice(0, 4)),
						"month": parseInt(parts[1].slice(5, 7)),
						"day": parseInt(parts[1].slice(8, 10)),
					},
					"time": {
						"hour": parseInt(parts[1].slice(11, 13)),
						"minute": parseInt(parts[1].slice(14, 16)),
						"second": parseInt(parts[1].slice(17, 19)),
					}
				};
			}
		});
		return {
			"local_resource_id": row["local_resource_id"],
			"event": {
				"name": row["name"],
				"begin": decode_datetime(row["begin"]),
				"end": (
					(row["end"] === null)
					?
					null
					:
					decode_datetime(row["end"])
				),
				"location": row["location"],
				"link": row["link"],
				"description": row["description"],
			}
		};
	}
	
	
	/**
	 */
	/*
	function encode_resource_core(
		stuff : {
			object : _zeitbild.type_resource_object;
			sub_id : int;
		}
	) : Record<string, any>
	{
		return {
			"kind": stuff.object.kind,
			"sub_id": stuff.sub_id
		};
	}
	 */
	
	
	/**
	 * @todo data
	 */
	/*
	function decode_resource_core(
		row : Record<string, any>
	) : {
		object : _zeitbild.type_resource_object;
		sub_id : int;
	}
	{
		return {
			"object": {
				"kind": row["kind"],
				"data": null,
			},
			"sub_id": row["sub_id"],
		};
	}
	 */
	
	
	/**
	 */
	export async function read(
		resource_id : _zeitbild.type_resource_id
	) : Promise<_zeitbild.type_resource_object>
	{
		const dataset_core : Record<string, any> = await get_resource_core_store().read(resource_id);
		switch (dataset_core.kind) {
			case "local": {
				const dataset_extra_local_core : Record<string, any> = await get_local_resource_core_store().read(dataset_core.sub_id);
				const datasets_extra_local_event_ids : Array<Record<string, any>> = await get_local_resource_event_store().search(
					{
						"expression": "(local_resource_id = $local_resource_id)",
						"arguments": {
							"local_resource_id": dataset_core.sub_id,
						}
					}
				);
				return Promise.resolve<_zeitbild.type_resource_object>(
					{
						"kind": "local",
						"data": {
							"event_ids": (
								datasets_extra_local_event_ids
								.map((hit) => hit.preview["id"])
							)
						}
					}
				);
			}
			case "ics_feed": {
				const dataset_extra_ics_feed : Record<string, any> = await get_ics_feed_resource_store().read(dataset_core.sub_id);
				return Promise.resolve<_zeitbild.type_resource_object>(
					{
						"kind": "ics_feed",
						"data": {
							"url": dataset_extra_ics_feed["url"],
							"from_fucked_up_wordpress": dataset_extra_ics_feed["from_fucked_up_wordpress"],
						}
					}
				);
				break;
			}
			default: {
				return Promise.reject<_zeitbild.type_resource_object>(
					new Error("invalid resource kind: " + dataset_core.kind)
				);
				break;
			}
		}
	}
	
	
	/**
	 */
	export async function create(
		resource_object : _zeitbild.type_resource_object
	) : Promise<_zeitbild.type_resource_id>
	{
		switch (resource_object.kind) {
			case "local": {
				const local_resource_id : int = await get_local_resource_core_store().create(
					{
						"_dummy": null,
					}
				);
				const resource_id : _zeitbild.type_resource_id = await get_resource_core_store().create(
					{
						"kind": "local",
						"sub_id": local_resource_id,
					}
				);
				await lib_plankton.cache.clear(_zeitbild.cache_regular);
				return Promise.resolve<_zeitbild.type_resource_id>(resource_id);
				break;
			}
			case "ics_feed": {
				const ics_feed_resource_id : int = await get_ics_feed_resource_store().create(
					{
						"url": resource_object.data.url,
						"from_fucked_up_wordpress": resource_object.data.from_fucked_up_wordpress,
					}
				);
				const resource_id : _zeitbild.type_resource_id = await get_resource_core_store().create(
					{
						"kind": "ics_feed",
						"sub_id": ics_feed_resource_id,
					}
				);
				await lib_plankton.cache.clear(_zeitbild.cache_regular);
				return Promise.resolve<_zeitbild.type_resource_id>(resource_id);
				break;
			}
			default: {
				// @ts-ignore
				throw (new Error("invalid resource kind: " + resource_object.kind));
				break;
			}
		}
	}
	
	
	/**
	 * @todo allow kind change?
	 */
	export async function update(
		resource_id : _zeitbild.type_resource_id,
		resource_object : _zeitbild.type_resource_object
	) : Promise<void>
	{
		const dataset_core : Record<string, any> = await get_resource_core_store().read(resource_id);
		if (dataset_core["kind"] !== resource_object.kind) {
			return Promise.reject(new Error("resource kind may not be altered"));
		}
		else {
			switch (resource_object.kind) {
				case "local": {
					// event_id list may not be altered directly
					/*
					const current_event_id_rows : {key : int; preview : Array<Record<string, any>>;} = await get_local_resource_event_chest().search(
						{
							"expression": "(local_resource_id = $local_resource_id)",
							"arguments": {
								"local_resource_id": dataset_core["sub_id"]
							}
						}
					);
					const contrast : {
						only_left : Array<{key : int; left : any;}>;
						both : Array<{key : int; left : any; right : any;}>;
						only_right : Array<{key : int; right : any;}>;
					} = lib_plankton.list.contrast<
						{key : Array<any>; preview : Record<string, any>;},
						_zeitbild.type_local_resource_event_id
					>(
						event_rows,
						(hit => hit.key),
						resource_object.data.event_ids,
						(x => x)
					);
					// TODO: single delete?
					for await (const entry of constrast.only_left) {
						await get_local_resource_event_store().delete(
							entry.key
						);
					}
					/*
					for await (const entry of contrast.both) {
						await get_local_resource_event_store().update(
							entry.left.key,
							encode_local_resource_event(entry.right.object)
						);
					}
					for await (const entry of contrast.only_right) {
						const event_id : type_local_resource_event_id = await get_local_resource_event_store().create(
							encode_local_resource_event(entry.right.object)
						);
					}
					 */
					break;
				}
				case "ics_feed": {
					await get_ics_feed_resource_store().update(
						dataset_core["sub_id"],
						{
							"url": resource_object.data.url,
							"from_fucked_up_wordpress": resource_object.data.from_fucked_up_wordpress,
						}
					);
					await lib_plankton.cache.clear(_zeitbild.cache_regular);
					break;
				}
				default: {
					// @ts-ignore
					throw (new Error("invalid resource kind: " + resource_object.kind));
					break;
				}
			}
		}
	}
	
	
	/**
	 */
	export async function local_resource_event_read(
		resource_id : _zeitbild.type_resource_id,
		local_resource_event_id : _zeitbild.type_local_resource_event_id
	) : Promise<_zeitbild.type_event_object>
	{
		const dataset_core : Record<string, any> = await get_resource_core_store().read(resource_id);
		if (! (dataset_core.kind === "local")) {
			throw (new Error("not a local resource"));
		}
		else {
			return (
				get_local_resource_event_store().read(
					local_resource_event_id
				)
				.then(
					(row) => Promise.resolve(decode_local_resource_event(row))
				)
				.then(
					(local_resource_event_stuff : type_local_resource_event_stuff) => Promise.resolve(
						local_resource_event_stuff.event
					)
				)
			);
		}
	}
	
	
	/**
	 */
	export async function local_resource_event_create(
		resource_id : _zeitbild.type_resource_id,
		event_object : _zeitbild.type_event_object
	) : Promise<_zeitbild.type_local_resource_event_id>
	{
		const dataset_core : Record<string, any> = await get_resource_core_store().read(resource_id);
		if (! (dataset_core.kind === "local")) {
			throw (new Error("not a local resource"));
		}
		else {
			const local_resource_event_id: _zeitbild.type_local_resource_event_id = await get_local_resource_event_store().create(
				encode_local_resource_event(
					{
						"local_resource_id": dataset_core["sub_id"],
						"event": event_object,
					}
				)
			);
			await lib_plankton.cache.clear(_zeitbild.cache_regular);
			return Promise.resolve(local_resource_event_id);
		}
	}
	
	
	/**
	 */
	export async function local_resource_event_update(
		resource_id : _zeitbild.type_resource_id,
		event_id : _zeitbild.type_local_resource_event_id,
		event_object : _zeitbild.type_event_object
	) : Promise<void>
	{
		const dataset_core : Record<string, any> = await get_resource_core_store().read(resource_id);
		if (! (dataset_core.kind === "local")) {
			throw (new Error("not a local resource"));
		}
		else {
			await get_local_resource_event_store().update(
				event_id,
				encode_local_resource_event(
					{
						"local_resource_id": dataset_core["sub_id"],
						"event": event_object,
					}
				)
			);
			await lib_plankton.cache.clear(_zeitbild.cache_regular);
			return Promise.resolve<void>(undefined);
		}
	}
	
	
	/**
	 */
	export async function local_resource_event_delete(
		resource_id : _zeitbild.type_resource_id,
		local_resource_event_id : _zeitbild.type_local_resource_event_id
	) : Promise<void>
	{
		await lib_plankton.cache.clear(_zeitbild.cache_regular);
		const dataset_core : Record<string, any> = await get_resource_core_store().read(resource_id);
		if (! (dataset_core.kind === "local")) {
			throw (new Error("not a local resource"));
		}
		else {
			return (
				get_local_resource_event_store().delete(
					local_resource_event_id
				)
				.then(
					() => Promise.resolve(undefined)
				)
			);
		}
	}
	
}
